package stonehill.edu.HibernateHelloWorld;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
public class DatabaseManipulator {
 

  /////////////////////////////////////////////////////////////
  // SELECT EXAMPLE
  /////////////////////////////////////////////////////////////
  public void selectExample()
  {
	System.out.println("Selecting records from account.");
	  
	Session session = HibernateUtility.getSessionFactory().openSession();
	session.beginTransaction();
    
	Query query = session.createQuery("from Account");
	List<Account> list = query.list();
	
    
    for (int i=0; i<list.size(); i++)
    {
    	System.out.println(list.get(i));
    }

    session.close();
  }

 /////////////////////////////////////////////////////////////
 // INSERT EXAMPLE
 /////////////////////////////////////////////////////////////
 public void insertExample()
 {
    System.out.println("Inserting record into account");
    
	Session session = HibernateUtility.getSessionFactory().openSession();
	session.beginTransaction();
    
	Account account = new Account("Becky Dugan", "Wayland, MA 01778", 32, 100000);
	session.save(account);
	
	session.getTransaction().commit();
	session.close();
	
 }

 /////////////////////////////////////////////////////////////
 // UPDATE EXAMPLE
 /////////////////////////////////////////////////////////////
 public void updateExample()
 {
	 System.out.println("Updating all account amounts by 10%");
		Session session = HibernateUtility.getSessionFactory().openSession();
		session.beginTransaction();
	    
		Query query = session.createQuery("from Account");
		List<Account> list = query.list();
	    
	    for (int i=0; i<list.size(); i++)
	    {
	    	Account account = list.get(i);
	    	account.setAmount(account.getAmount()*1.1);
	    	// No need to update directly because the account objects are 
	    	// considered persistent objects.  Any change is automatically
	    	// reflected in the database!
	    }
	    
	    session.getTransaction().commit();
	    session.close();
 }

/////////////////////////////////////////////////////////////
// DELETE EXAMPLE
/////////////////////////////////////////////////////////////
 public void deleteExample()
 {
	 	System.out.println("Deleting account with id 32");
		Session session = HibernateUtility.getSessionFactory().openSession();
		session.beginTransaction();
		
		Account account = (Account) session.load(Account.class, 32);
		session.delete(account);
		
		session.getTransaction().commit();
		session.close();
}
 
}
